{
   20.07.2001
            
}
	

{$DEFINE USE_PICTURES}
{$DEFINE USE_WMActivate}

UNIT UMines;

INTERFACE

USES
   Windows, Messages, SysUtils, Graphics, Forms, ExtCtrls, Classes, Controls,
   StdCtrls, Buttons, Menus;

TYPE
   TSkillLevel         = ( SkillLevelBeginner    , SkillLevelAmateur,
                           SkillLevelProfessional, SkillLevelCrazy  );
   TSubrangeSkillLevel = Ord(Low(TSkillLevel))..Ord(High(TSkillLevel));
   TArrSkillLevel      = array[TSubrangeSkillLevel] of Integer;

CONST
   CMaxX = 45;//45;
   CMaxY = 25;//25;
                               // Beginner Amateur Professional Crazy
   CSizeX     : TArrSkillLevel = ( 10     , 20    , 30         , CMaxX );
   CSizeY     : TArrSkillLevel = ( 10     , 15    , 20         , CMaxY );
   CSkillLevel: TArrSkillLevel = ( 15{%}  , 18{%} , 21{%}      , 25{%} ); // Number mines
   CCraters   : TArrSkillLevel = (  7{%}  ,  8{%} ,  9{%}      , 10{%} ); // Number craters

TYPE
  TFrm_Mines = Class(TForm)
    pnl_Top               : TPanel;
    pnl_Field             : TPanel;
    bttn_New              : TSpeedButton;
    bttn_Pause            : TSpeedButton;
    bttn_New1             : TSpeedButton;
    bttn_New2             : TSpeedButton;
    bttn_New3             : TSpeedButton;
    bttn_New4             : TSpeedButton;
    bttn_Pause1           : TSpeedButton;
    bttn_Pause2           : TSpeedButton;
    Timer                 : TTimer;
    edt_Count             : TEdit;
    edt_Timer             : TEdit;
    menu_Mines            : TMainMenu;
    mnitm_File            : TMenuItem;
    mnitm_Help            : TMenuItem;
    mnitm_FileNewGame     : TMenuItem;
    mnitm_FileSplitter1   : TMenuItem;
    mnitm_FileBeginner    : TMenuItem;
    mnitm_FileAmateur     : TMenuItem;
    mnitm_FileProfessional: TMenuItem;
    mnitm_FileCrazy       : TMenuItem;
    mnitm_FileCustom      : TMenuItem;
    mnitm_FileSplitter2   : TMenuItem;
    mnitm_FileExit        : TMenuItem;
    mnitm_HelpChampions   : TMenuItem;
    mnitm_HelpSplitter    : TMenuItem;
    mnitm_HelpAbout       : TMenuItem;
    mnitm_FileMinimize    : TMenuItem;
    mnitm_FileNewGame2    : TMenuItem;
    img_Pause             : TImage;
    mnitm_FilePause: TMenuItem;
    procedure pnl_TopResize         (Sender: TObject);
    procedure TimerOn               (Sender: TObject);
    Procedure ResetField            (Sender: TObject);
    Procedure CreateField           (Sender: TObject);
    procedure FormCreate            (Sender: TObject);
    procedure bttn_PauseClick       (Sender: TObject);
    procedure edt_CountChange       (Sender: TObject);
    procedure bttn_NewClick         (Sender: TObject);
    procedure mnitm_FileExitClick   (Sender: TObject);
    procedure edt_EditMouseDown     (Sender: TObject; Button: TMouseButton;
                                     Shift : TShiftState; X, Y: Integer);
    Procedure BeginGame             ( no_x,no_y : Integer);
    Procedure EndGame               ( Victory: Boolean );
    procedure mnitm_FileCustomClick      (Sender: TObject);
    procedure mnitm_FileBeginnerClick    (Sender: TObject);
    procedure mnitm_FileAmateurClick     (Sender: TObject);
    procedure mnitm_FileProfessionalClick(Sender: TObject);
    procedure mnitm_FileCrazyClick       (Sender: TObject);
    procedure mnitm_HelpAboutClick       (Sender: TObject);
    procedure mnitm_HelpChampionsClick   (Sender: TObject);
    procedure FormClose                  (Sender: TObject; var Action: TCloseAction);
    procedure mnitm_FileMinimizeClick    (Sender: TObject);
    procedure mnitm_FilePauseClick(Sender: TObject);
  private
    { Private declarations }
{$IFDEF USE_WMActivate}
    procedure WMActivate(var Message: TWMActivate); message WM_ACTIVATE;
{$ENDIF}
  public
    { Public declarations }
  End;

VAR
   frm_Mines: Tfrm_Mines;
   X: Integer; // 
   Y: Integer; // 
   SkillLevel: TSkillLevel;

IMPLEMENTATION

USES UOptions, UAbout, UChampions, UDialog;

TYPE
   TStateCell       = ( _Open, _Close );
   TCellOpen        = ( _Null, _1, _2, _3, _4, _5, _6, _7, _8, _Mine );
   TCellClose       = ( _Clear, _Flag, _Unknown );
   TSubrangeOpen    = Ord(Low(TCellOpen ))..Ord(High(TCellOpen ));
   TSubrangeClose   = Ord(Low(TCellClose))..Ord(High(TCellClose));
   TArrColorOpen    = array[TSubrangeOpen ] of Integer;
   TArrColorClose   = array[TSubrangeClose] of Integer;
   TArrCaptionOpen  = array[TSubrangeOpen ] of Char;
   TArrCaptionClose = array[TSubrangeClose] of Char;

CONST
   CFormCaption    = 'Mines';
   CFileNameInit   = 'Mines.ini';

   CHeightTopPanel = 40;
   CSizeCell       = 17;
   CSizeBMP        = 11;

   CCaptionOpen: TArrCaptionOpen =
   (  ' ', // _Null
      '1', // _1
      '2', // _2
      '3', // _3
      '4', // _4
      '5', // _5
      '6', // _6
      '7', // _7
      '8', // _8
      '*'  // _Mine
   );
   CCaptionClose: TArrCaptionClose =
   (  ' ', // _Clear
      'F', // _Flag
      '?'  // _Unknown
   );

   CColorOpen: TArrColorOpen =
   (  clBlack , // _Null  
      clNavy  , // _1     
      clGreen , // _2     
      clRed   , // _3     
      clMaroon, // _4      ???
      clBlue  , // _5     
      clBlack , // _6     
      clOlive , // _7     - ???
      clAqua  , // _8     
      clBlack   // _Mine  
   );
   CColorClose: TArrColorClose =
   (  clBlack , // _Clear    
      clRed   , // _Flag     
      clTeal    // _Unknown  -
   );

TYPE
   TArrayBMP       = array[1..CSizeBMP      ,1..CSizeBMP      ] of TColor;

CONST
   CVictory = True;
   CDefeat  = False;

   ________ = clBtnFace; //Current color of a button face

   CBMPMine: TArrayBMP =
      ((________,________,________,________,________,clGray  ,________,________,________,________,________), // 1
       (________,________,________,________,________,clBlack ,________,________,________,________,________), // 2
       (________,________,clBlack ,________,clGray  ,clBlack ,clGray  ,________,clBlack ,________,________), // 3
       (________,________,________,clBlack ,clBlack ,clBlack ,clBlack ,clBlack ,________,________,________), // 4
       (________,________,clGray  ,clBlack ,________,clBlack ,clBlack ,clBlack ,clGray  ,________,________), // 5
       (clGray  ,clBlack ,clBlack ,clBlack ,clBlack ,clBlack ,clBlack ,clBlack ,clBlack ,clBlack ,clGray  ), // 6
       (________,________,clGray  ,clBlack ,clBlack ,clBlack ,clBlack ,clBlack ,clGray  ,________,________), // 7
       (________,________,________,clBlack ,clBlack ,clBlack ,clBlack ,clBlack ,________,________,________), // 8
       (________,________,clBlack ,________,clGray  ,clBlack ,clGray  ,________,clBlack ,________,________), // 9
       (________,________,________,________,________,clBlack ,________,________,________,________,________), // 10
       (________,________,________,________,________,clGray  ,________,________,________,________,________));// 11

   CBMPFlag: TArrayBMP =
      ((________,________,________,________,________,________,________,________,________,________,________), // 1
       (________,________,clRed   ,clRed   ,clRed   ,clRed   ,clMaroon,________,________,________,________), // 2
       (________,________,clRed   ,clRed   ,clRed   ,clMaroon,clMaroon,________,________,________,________), // 3
       (________,________,clRed   ,clRed   ,clMaroon,clMaroon,clMaroon,________,________,________,________), // 4
       (________,________,clRed   ,clMaroon,clMaroon,clMaroon,clMaroon,________,________,________,________), // 5
       (________,________,________,________,________,________,clBlack ,________,________,________,________), // 6
       (________,________,________,________,________,________,clBlack ,________,________,________,________), // 7
       (________,________,________,________,________,________,clBlack ,________,________,________,________), // 8
       (________,________,________,________,________,________,clBlack ,________,________,________,________), // 9
       (________,________,________,________,________,clGray  ,clBlack ,clGray  ,________,________,________), // 10
       (________,________,________,clGray  ,clBlack ,clBlack ,clBlack ,clBlack ,clBlack ,clGray  ,________));// 11



TYPE
   TNeighbor  = -1..1;
   TCell = Class(TObject)
      published
      protected
      private
         //Err    : Boolean;
         Down   : Boolean; // is down ?
         Caption: String;  // text in caption
         X1, Y1 : Integer; // LeftTopX, LeftTopY
         X2, Y2 : Integer; // RightBottomX, RightBottomY
         State    : TStateCell;
         CellOpen : TCellOpen ;
         CellClose: TCellClose;
         i, j     : Integer; // coordinate in Field array
         Constructor CreateCell( newX, newY: Integer );
         Procedure Paint;
      public
         Procedure LButtonDown;
         Procedure LButtonUp( point: TPoint );
         Procedure RButtonDown;
   End;

   TArrMinePanel = array [0..CMaxX-1,0..CMaxY-1]of TCell; // Delphi3
   //TArrMinePanel = array of array of TCell; // Delphi5

TYPE
   TImageCells = Class(TImage)
      protected
         //procedure Paint; override;
         procedure WMPaint(var Message: TWMPaint); message WM_PAINT;
      public
         Procedure WMLButtonDown(var msg: TWMLButtonDown); message WM_LButtonDown;
         Procedure WMLButtonUp  (var msg: TWMLButtonUp  ); message WM_LButtonUp;
         Procedure WMRButtonDown(var msg: TWMRButtonDown); message WM_RButtonDown;
         Procedure WMLButtonDblClk(var msg: TWMLButtonDblClk); message WM_LButtonDblClk;
         Procedure WMRButtonDblClk(var msg: TWMRButtonDblClk); message WM_RButtonDblClk;
   End;

////////////////////////////////////////////////////////////////////////////////
//                             forward declaration                            //
////////////////////////////////////////////////////////////////////////////////
Procedure SaveResult;         forward;
Function  Statistics: String; forward;

////////////////////////////////////////////////////////////////////////////////
//                          globals variables this module                     //
////////////////////////////////////////////////////////////////////////////////
VAR
   useCraters    : Boolean;
   Pause         : Boolean;
   GameProcessing: Boolean;
   Field         : TArrMinePanel;
   img_Cells     : TImageCells;
   gLmsg         : TWMMouse;
   isRefresh     : Boolean;
   minesNumber   : Integer; // - 
   numberCraters : Integer; // - 
   openCount     : Integer; //     
   flagCount     : Integer; //     

{$R *.DFM}

////////////////////////////////////////////////////////////////////////////////
//                                  TCell                                     //
////////////////////////////////////////////////////////////////////////////////
Constructor TCell.CreateCell( newX, newY: Integer );
Begin
   Self.State    := _Close;
   Self.CellOpen := _Null;
   Self.CellClose:= _Clear;
   Self.i:= newX;
   Self.j:= newY;
   Self.X1:= CSizeCell * Self.i;// + 2;
   Self.Y1:= CSizeCell * Self.j;// + 2;
   Self.X2:= Self.X1 + CSizeCell;// - 1;
   Self.Y2:= Self.Y1 + CSizeCell;// - 1;
End;

Procedure TCell.LButtonDown;
Var m, n: TNeighbor;
Begin
   inherited;
{$IFDEF USE_PICTURES}
   frm_Mines.bttn_New.Glyph:= frm_Mines.bttn_New2.Glyph;
{$ENDIF}
   if (not GameProcessing) then frm_Mines.BeginGame(Self.i,Self.j);
   if (Self.CellClose = _Flag) then Exit;
   Self.Down:= True;
   Self.Paint;
   frm_Mines.bttn_Pause.Enabled:= True;
   //     
   if (Self.State = _Open) then
      for m:= -1 to 1 do
         for n:= -1 to 1 do
            if ((m = 0 ) and (  n = 0 )) or
               (i+m < 0)  or (i+m > X-1) or
               (j+n < 0)  or (j+n > Y-1) or
               (Field[i+m,j+n].State     = _Open) or
               (Field[i+m,j+n].CellClose = _Flag) then Continue
            else begin
               Field[i+m,j+n].Down:= True;
               Field[i+m,j+n].Paint;
            end;
End;

Procedure TCell.LButtonUp( point: TPoint );
Var countFlags: Integer;
    countClear: Integer;
    m, n      : TNeighbor;
    newPoint  : TPoint;
Begin
   inherited;
{$IFDEF USE_PICTURES}
   if (GameProcessing) then frm_Mines.bttn_New.Glyph:= frm_Mines.bttn_New1.Glyph;
{$ENDIF}
   frm_Mines.Timer.Enabled:= True;
   if (Self.CellClose = _Flag) then Exit;
   //    
   for m:= -1 to 1 do
      for n:= -1 to 1 do
         if ((m = 0 ) and (  n = 0 )) or
            (i+m < 0)  or (i+m > X-1) or
            (j+n < 0)  or (j+n > Y-1) or
            (Field[i+m,j+n].State     = _Open) or
            (Field[i+m,j+n].CellClose = _Flag) then Continue
         else begin
            Field[i+m,j+n].Down:= False;
            Field[i+m,j+n].Paint;
         end;
   if (Self.State <> _Open) and
      ((point.x < Self.X1) or (point.x > Self.X2) or
       (point.y < Self.Y1) or (point.y > Self.Y2)) then begin
      Self.Down:= False;
      Self.Paint;
      Exit;
   end;
   if (Self.State <> _Open) then begin
      Self.State:= _Open;
      Inc(openCount);
      Self.Paint;
      frm_Mines.edt_Count.Hint:= Statistics;
   end;
   //  -       
   countFlags:= 0;
   countClear:= 0;
   for m:= -1 to 1 do
      for n:= -1 to 1 do begin
         if ((m = 0 ) and ( n = 0)) or
            (i+m < 0)  or (i+m > X-1) or
            (j+n < 0)  or (j+n > Y-1) or
            (Field[i+m,j+n].State = _Open) then Continue
         else if (Field[i+m,j+n].CellClose = _Flag) // State = _Close
            then Inc(countFlags)
            else Inc(countClear);
      end;
   //   
   if countFlags+countClear = Ord(Self.CellOpen) then
      for m:= -1 to 1 do
         for n:= -1 to 1 do
            if ((m = 0 ) and ( n = 0 )) or
               (i+m < 0)  or (i+m > X-1) or
               (j+n < 0)  or (j+n > Y-1) or
               (Field[i+m,j+n].State     = _Open) or
               (Field[i+m,j+n].CellClose = _Flag) then Continue
            else begin
               Inc(flagCount);
               frm_Mines.edt_Count.Text:= IntToStr( minesNumber-flagCount );
               Field[i+m,j+n].CellClose:= _Flag;
               Field[i+m,j+n].Paint;
            end;
   if (point.x < Self.X1) or (point.x > Self.X2) or
      (point.y < Self.Y1) or (point.y > Self.Y2) then Exit;
   //  
   if countFlags = Ord(Self.CellOpen) then
      for m:= -1 to 1 do
         for n:= -1 to 1 do
            if ((m = 0 ) and ( n = 0)) or
               (i+m < 0)  or (i+m > X-1) or
               (j+n < 0)  or (j+n > Y-1) or
               (Field[i+m,j+n].CellClose = _Flag) or
               (Field[i+m,j+n].State     = _Open) then Continue
            else begin
               Field[i+m,j+n].Down:= True;
               Field[i+m,j+n].State:= _Open;
               Inc(openCount);
               Field[i+m,j+n].Paint;
               frm_Mines.edt_Count.Hint:= Statistics;
               if (Field[i+m,j+n].CellOpen = _Mine)  then frm_Mines.EndGame(CDefeat);
               if (Field[i+m,j+n].CellOpen <> _Null) then Continue;
               newPoint.x:= point.x + m*CSizeCell;
               newPoint.y:= point.y + n*CSizeCell;
               Field[i+m,j+n].LButtonUp( newPoint );
            end;
   if {(Self.State   = _Open) and } //    
      (GameProcessing) then begin
      if (Self.CellOpen = _Mine)       then frm_Mines.EndGame(CDefeat);
      if (openCount+minesNumber = X*Y) then frm_Mines.EndGame(CVictory);
   end;
End;

Procedure TCell.RButtonDown;//(var msg : TwmRButtonDown);
Begin
   inherited;
   frm_Mines.bttn_Pause.Enabled:= True;
   frm_Mines.Timer.Enabled:= True;
   if (Self.State = _Open) then Exit;
   case Self.CellClose of
      _Clear  : begin
                   Self.CellClose:= _Flag;
                   Inc(flagCount);
                   frm_Mines.edt_Count.Text:= IntToStr( minesNumber-flagCount );
                end;
      _Flag   : begin
                   Self.CellClose:= _Unknown;
                   Dec(flagCount);
                   frm_Mines.edt_Count.Text:= IntToStr( minesNumber-flagCount );
                end;
      _Unknown: Self.CellClose:= _Clear;
   end;
   Self.Paint;
End;

Procedure TCell.Paint;
Const
   CDelta = (CSizeCell - CSizeBMP) shr 1-1;
Var
   heightText: Integer;
   rectan: TRect;
   i,j: Integer;
Begin
   inherited;
   //  - (Brush)
   {
   if (Self.Err)
      then img_Cells.Canvas.Brush.Color:= clRed
      else img_Cells.Canvas.Brush.Color:= clBtnFace; //Current color of a button face
   }
   img_Cells.Canvas.Brush.Color:= clBtnFace; //Current color of a button face
   img_Cells.Canvas.Brush.Style:= bsSolid; // bsSolid bsCross bsClear bsDiagCross bsBDiagonal bsHorizontal bsFDiagonal bsVertical
   //  - (Pen)
   img_Cells.Canvas.Pen.Style:= psSolid;
   img_Cells.Canvas.Pen.Color:= clBlack;
   img_Cells.Canvas.Rectangle(Self.X1,Self.Y1,Self.X2,Self.Y2);
   img_Cells.Canvas.Pen.Color:= clWhite;
   if (Self.Down) then begin
      img_Cells.Canvas.MoveTo(X2-1,Y1);
      img_Cells.Canvas.LineTo(X2-1,Y2-1);
      img_Cells.Canvas.LineTo(X1-1,Y2-1);
   end else begin
      img_Cells.Canvas.MoveTo(X1,Y2-2);
      img_Cells.Canvas.LineTo(X1,Y1);
      img_Cells.Canvas.LineTo(X2-1,Y1);
   end;
   //
{$IFDEF USE_PICTURES}
   // output BMP
   if (Self.State = _Close) and (Self.CellClose = _Flag) then
      for i:= 1 to CSizeBMP do
         for j:= 1 to CSizeBMP do
            if (Self.Down) //and (CBMPFlag[j,i] <> ________)
               then img_Cells.Canvas.Pixels[X1+CDelta+i+1,Y1+CDelta+j+1]:= CBMPFlag[j,i]
               else img_Cells.Canvas.Pixels[X1+CDelta+i  ,Y1+CDelta+j  ]:= CBMPFlag[j,i]
   else
   if (Self.State = _Open) and (Self.CellOpen = _Mine) then
      for i:= 1 to CSizeBMP do
         for j:= 1 to CSizeBMP do
            if (Self.Down) //and (CBMPMine[j,i] <> ________)
               then img_Cells.Canvas.Pixels[X1+CDelta+i+1,Y1+CDelta+j+1]:= CBMPMine[j,i]
               else img_Cells.Canvas.Pixels[X1+CDelta+i  ,Y1+CDelta+j  ]:= CBMPMine[j,i]
   else
{$ENDIF}
   // output text
   begin
      rectan:= rect(0,0,0,0);
      heightText:= DrawText(img_Cells.Canvas.Handle, ' ', -1, rectan, dt_Center or dt_VCenter );
      rectan:= rect(Self.X1,Self.Y1,Self.X2,Self.Y2);
      rectan.top:= ((rectan.bottom + rectan.top) - heightText) shr 1;
      if (Self.Down) then begin
         rectan.top := rectan.top  + 1;
         rectan.left:= rectan.left + 1;
      end;
      // 
      //img_Cells.Canvas.Font.Size:= 10;
      //img_Cells.Canvas.Font.Height:= -11;
      img_Cells.Canvas.Font.Style:= [fsBold];//(fsBold, fsItalic, fsUnderline, fsStrikeOut)
      if (Self.State = _Close) then begin
         img_Cells.Canvas.Font.Color:= CColorClose  [Ord(Self.CellClose)];
         Self.Caption               := CCaptionClose[Ord(Self.CellClose)];
      end else begin
         img_Cells.Canvas.Font.Color:= CColorOpen   [Ord(Self.CellOpen )];
         Self.Caption               := CCaptionOpen [Ord(Self.CellOpen )];
      end;
      //  -  
      {
      if (Self.Err)
         then img_Cells.Canvas.Brush.Color:= clRed
         else img_Cells.Canvas.Brush.Color:= clBtnFace; //Current color of a button face
      }
      img_Cells.Canvas.Brush.Color:= clBtnFace; //Current color of a button face
      img_Cells.Canvas.Brush.Style:= bsClear; // bsSolid bsCross bsClear bsDiagCross bsBDiagonal bsHorizontal bsFDiagonal bsVertical
      DrawText( img_Cells.Canvas.Handle, PChar(Self.Caption),
                -1, rectan, dt_Center or dt_VCenter );
   end;
End;

////////////////////////////////////////////////////////////////////////////////
//                               TFrm_Mines                                   //
////////////////////////////////////////////////////////////////////////////////
Procedure TFrm_Mines.bttn_PauseClick(Sender: TObject);
Begin
   Pause        := bttn_Pause.Down;
   Timer.Enabled:= not Pause;
   if Pause then begin
      img_Cells.Hide;
{$IFDEF USE_PICTURES}
      img_Pause.Show;
{$ENDIF}
   end else begin
      img_Cells.Show;
{$IFDEF USE_PICTURES}
      img_Pause.Hide;
{$ENDIF}
   end;
   isRefresh:= Pause;
{$IFDEF USE_PICTURES}
   if (Pause) then
      bttn_Pause.Glyph:= bttn_Pause2.Glyph
   else
      bttn_Pause.Glyph:= bttn_Pause1.Glyph;
{$ENDIF}
End;

Procedure TFrm_Mines.BeginGame( no_x,no_y : Integer);
Var count: Integer;
    i, j : Integer;
    m, n : TNeighbor;
Begin
   GameProcessing:= True;
   // cell
      // set random mines
   count:= 0;
   repeat
      i:= Random(X);
      j:= Random(Y);
      {}
      if ((i <> no_x-1) or (j <> no_y+1)) and // 1
         ((i <> no_x  ) or (j <> no_y+1)) and // 2
         ((i <> no_x+1) or (j <> no_y+1)) and // 3
         ((i <> no_x-1) or (j <> no_y  )) and // 4
         ((i <> no_x  ) or (j <> no_y  )) and // 5
         ((i <> no_x+1) or (j <> no_y  )) and // 6
         ((i <> no_x-1) or (j <> no_y-1)) and // 7
         ((i <> no_x  ) or (j <> no_y-1)) and // 8
         ((i <> no_x+1) or (j <> no_y-1)) and // 9
          (Field[i,j].CellOpen <> _Mine) then //      
      begin
         Field[i,j].CellOpen:= _Mine;
         Inc( count );
      end;
      {}
   until count >= minesNumber;
   // set other CellOpen and set all Caption
   for i:= 0 to X-1 do
      for j:= 0 to Y-1 do begin
         if(Field[i,j].CellOpen <> _Mine) then begin
            count:= 0;
            for m:= -1 to 1 do
               for n:= -1 to 1 do
                  if ((m = 0 ) and (  n = 0 )) or
                     (i+m < 0)  or (i+m > X-1) or
                     (j+n < 0)  or (j+n > Y-1) or
                     (Field[i+m,j+n].CellOpen <> _Mine) then Continue
                  else Inc( count );
            Field[i,j].CellOpen:= TCellOpen(count);
         end;
      end;
End;

Procedure TFrm_Mines.edt_EditMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Begin
   edt_Count.Enabled:= False;
   edt_Count.Enabled:= True;
   edt_Timer.Enabled:= False;
   edt_Timer.Enabled:= True;
End;

Procedure Tfrm_Mines.pnl_TopResize(Sender: TObject);
Begin
   bttn_New  .Left:= pnl_Top.Width div 2  -  bttn_New.Width;
   bttn_Pause.Left:= pnl_Top.Width div 2;
   edt_Count .Left:= 10;
   edt_Timer .Left:= pnl_Top.Width - edt_Timer.Width - 10;

   bttn_New  .Top:= pnl_Top.Height div 2  -  bttn_New  .Height div 2;
   bttn_Pause.Top:= pnl_Top.Height div 2  -  bttn_Pause.Height div 2;
   edt_Count .Top:= pnl_Top.Height div 2  -  edt_Count .Height div 2;
   edt_Timer .Top:= pnl_Top.Height div 2  -  edt_Timer .Height div 2;
End;

Procedure TFrm_Mines.TimerOn(Sender: TObject);
Begin
   Timer.DesignInfo:= Timer.DesignInfo + 1;
   edt_Timer.Text:= IntToStr(Timer.DesignInfo);
End;

Procedure TFrm_Mines.ResetField(Sender: TObject);
Var i,j: Integer;
Begin
   Timer.DesignInfo:= 0;
   Timer.Enabled   := False;
   edt_Timer.Text  := IntToStr(Timer.DesignInfo);
   for i:= 0 to X-1 do
      for j:= 0 to Y-1 do Field[i,j].Destroy;
End;

Procedure TFrm_Mines.FormCreate(Sender: TObject);
Var F: File of Integer;
    tmp:Integer;
Begin
   img_Cells:= TImageCells.Create(pnl_Field);
   Self.pnl_Field.InsertControl(img_Cells);
   img_Cells.Align:= alClient;  // -  
   img_Cells.Width := GetDeviceCaps(GetDC(GetDesktopWindow()),HorzRes); // 
   img_Cells.Height:= GetDeviceCaps(GetDC(GetDesktopWindow()),VertRes); // 
   Caption:= CFormCaption;
   Randomize;
   AssignFile(F,CFileNameInit);
{$IFDEF USE_PICTURES}
   //img_Pause.Visible:= False;
   bttn_New  .Glyph  := bttn_New1  .Glyph;
   bttn_Pause.Glyph  := bttn_Pause1.Glyph;
   bttn_New  .Caption:= '';
   bttn_Pause.Caption:= '';
{$ELSE}
   bttn_New  .Glyph  := Nil;
   bttn_Pause.Glyph  := Nil;
   bttn_New  .Caption:= 'N';
   bttn_Pause.Caption:= 'P';
{$ENDIF}
   try
      Reset(F);
   except
      mnitm_FileBeginnerClick(Sender);
      Exit;
   end;
   Read(F,X,Y,tmp);
   CloseFile(F);
   SkillLevel:= TSkillLevel(tmp);
   if (X = CSizeX[0]) and (Y = CSizeY[0]) and (SkillLevel = SkillLevelBeginner    )
   then mnitm_FileBeginner    .Checked:= True else
   if (X = CSizeX[1]) and (Y = CSizeY[1]) and (SkillLevel = SkillLevelAmateur     )
   then mnitm_FileAmateur     .Checked:= True else
   if (X = CSizeX[2]) and (Y = CSizeY[2]) and (SkillLevel = SkillLevelProfessional)
   then mnitm_FileProfessional.Checked:= True else
   if (X = CSizeX[3]) and (Y = CSizeY[3]) and (SkillLevel = SkillLevelCrazy       )
   then mnitm_FileCrazy       .Checked:= True else
        mnitm_FileCustom      .Checked:= True;
   frm_Mines.CreateField(Sender);
End;

Procedure TFrm_Mines.CreateField(Sender: TObject);
Var i,j: Integer;
    winX, winY: Integer;
Begin
   winX:= GetDeviceCaps(GetDC(GetDesktopWindow()),HorzRes);
   winY:= GetDeviceCaps(GetDC(GetDesktopWindow()),VertRes);
   ReleaseDC(GetDC(GetDesktopWindow()),GetDesktopWindow()); // ???
   pnl_Top.Height:= CHeightTopPanel;
   Self.Height:= Y*CSizeCell + CHeightTopPanel + 28 + 18{=menu_Mines.Height};
   Self.Width := X*CSizeCell + 8;
   Self.Left  := winX div 2 - Self.Width  div 2;
   Self.Top   := winY div 2 - Self.Height div 2;
   //SetLength(Field,X,Y); // Delphi5
   for i:= 0 to X-1 do
      for j:= 0 to Y-1 do
         Field[i,j]:= TCell.CreateCell(i,j);
   Pause:= False;
   Self.bttn_NewClick(Sender);
End;

Procedure TFrm_Mines.EndGame( Victory: Boolean );
Var i,j: Integer;
Begin
   if (not GameProcessing) then Exit;
   GameProcessing:= False;
   Timer.Enabled:= False;
   //  e
   (**)
   // variant 1
   if (Victory) then begin
      for i:= 0 to X-1 do
         for j:= 0 to Y-1 do begin
            if (Field[i,j].State = _Close) then begin
               if (Field[i,j].CellOpen = _Mine) then
                  Field[i,j].CellClose:= _Flag
               else begin
                  Field[i,j].State:= _Open;
                  Field[i,j].Down:= True
               end;
               Field[i,j].Paint;
            end;
         end;
      flagCount:= minesNumber;
      frm_Mines.edt_Count.Text:= '0';
      frm_Mines.edt_Count.Hint:= Statistics;
   end else begin
      for i:= 0 to X-1 do
         for j:= 0 to Y-1 do begin
            //if (Field[i,j].State = _Open) then Continue;
            {
            if (Field[i,j].CellClose = _Flag) and
               (Field[i,j].CellOpen <> _Mine) then Field[i,j].Err:= True;
            if (Field[i,j].CellOpen  = _Mine) and
               (Field[i,j].Down) then Field[i,j].Err:= True;
            {}
            Field[i,j].State:= _Open;
            if (Field[i,j].CellClose = _Flag) and
               (Field[i,j].CellOpen  = _Mine) then Field[i,j].State:= _Close;
            Field[i,j].Paint;
         end;
   end;
   (*
   // variant 2
   for i:= 0 to X-1 do
      for j:= 0 to Y-1 do begin
         if (Field[i,j].State = _Open) or
            (Field[i,j].State = _Close) and
            (Field[i,j].CellClose = _Flag) then Continue;
         Field[i,j].State:= _Open;
         Field[i,j].Paint;
      end;
   if (Victory) then begin
      flagCount:= minesNumber;
      frm_Mines.edt_Count.Text:= '0';
      frm_Mines.edt_Count.Hint:= Statistics;
   end;
   (**)
   pnl_Field.Enabled:= False; // disable all cell
   frm_Mines.bttn_Pause.Enabled:= False;
   Beep;
   if Victory then begin
{$IFDEF USE_PICTURES}
      bttn_New.Glyph:= bttn_New3.Glyph;
{$ENDIF}
      frm_Mines.Caption:= CFormCaption + ' - Victory';
      SaveResult;
   end else begin
{$IFDEF USE_PICTURES}
      bttn_New.Glyph:= bttn_New4.Glyph;
{$ENDIF}
      frm_Mines.Caption:= CFormCaption + ' - Defeat';
   end;
End;

Procedure TFrm_Mines.edt_CountChange(Sender: TObject);
Var i,j: Integer;
Begin
   if (minesNumber = flagCount) and (GameProcessing) then begin
      for i:= 0 to X-1 do
         for j:= 0 to Y-1 do
            if (Field[i,j].CellClose = _Flag) and
               (Field[i,j].CellOpen <> _Mine) then
               Exit; //    -  
      EndGame(CVictory);
   end;
End;

Procedure Tfrm_Mines.bttn_NewClick(Sender: TObject);
Var i,j: Integer;
Begin
   //if (Timer.DesignInfo=0)and(not GameProcessing) then Exit; // !!!!!!!!!!!!!!!
   if (Pause) then begin
      bttn_Pause.Down:= False;
      bttn_PauseClick(Sender);
      Exit;
   end;
{$IFDEF USE_PICTURES}
   bttn_New.Glyph  := bttn_New1.Glyph;
   bttn_Pause.Glyph:= bttn_Pause1.Glyph;
{$ENDIF}
   GameProcessing:= False;
   frm_Mines.Caption:= CFormCaption;
   img_Cells.Show;
   img_Pause.Hide;
   pnl_Field.Enabled:= True; // enable all cell
   // pause
   Pause             := False;
   bttn_Pause.Down   := False;
   bttn_Pause.Enabled:= False;
   // timer
   Timer.DesignInfo:= 0;
   Timer.Enabled   := False;
   edt_Timer.Text:= IntToStr(Timer.DesignInfo);
   // cell
      // beginner reset
   for i:= 0 to X-1 do
      for j:= 0 to Y-1 do begin
         Field[i,j].State    := _Close;
         Field[i,j].CellOpen := _Null;
         Field[i,j].CellClose:= _Clear;
         //Field[i,j].Err    := False;
         Field[i,j].Down     := False;
         Field[i,j].Caption  := '';
         Field[i,j].Paint;
     end;
   minesNumber:= X*Y*CSkillLevel[Ord(SkillLevel)] div 100;
   isRefresh:= True;
   flagCount:= 0;
   openCount:= 0;
   edt_Count.Text:= IntToStr(minesNumber-flagCount);
   edt_Count.Hint:= Statistics;
End;

Procedure Tfrm_Mines.mnitm_FileExitClick(Sender: TObject);
Begin
   frm_Mines.Close;
End;

Procedure Tfrm_Mines.mnitm_FileCustomClick(Sender: TObject);
Begin
   mnitm_FileCustom.Checked:= True;
   frm_Options.ShowModal;
End;

Procedure Tfrm_Mines.mnitm_FileBeginnerClick(Sender: TObject);
Begin
   mnitm_FileBeginner.Checked:= True;
   frm_Mines.ResetField(Sender);
   SkillLevel:= SkillLevelBeginner;
   X:= CSizeX[0];
   Y:= CSizeY[0];
   frm_Mines.CreateField(Sender);
End;

Procedure Tfrm_Mines.mnitm_FileAmateurClick(Sender: TObject);
Begin
   mnitm_FileAmateur.Checked:= True;
   frm_Mines.ResetField(Sender);
   SkillLevel:= SkillLevelAmateur;
   X:= CSizeX[1];
   Y:= CSizeY[1];
   frm_Mines.CreateField(Sender);
End;

Procedure Tfrm_Mines.mnitm_FileProfessionalClick(Sender: TObject);
Begin
   mnitm_FileProfessional.Checked:= True;
   frm_Mines.ResetField(Sender);
   SkillLevel:= SkillLevelProfessional;
   X:= CSizeX[2];
   Y:= CSizeY[2];
   frm_Mines.CreateField(Sender);
End;

Procedure Tfrm_Mines.mnitm_FileCrazyClick(Sender: TObject);
Begin
   //Pause:= False;
   mnitm_FileCrazy.Checked:= True;
   frm_Mines.ResetField(Sender);
   SkillLevel:= SkillLevelCrazy;
   X:= CSizeX[3];
   Y:= CSizeY[3];
   frm_Mines.CreateField(Sender);
End;

Procedure Tfrm_Mines.mnitm_HelpAboutClick(Sender: TObject);
Begin
   frm_About.ShowModal;
End;

Procedure Tfrm_Mines.mnitm_HelpChampionsClick(Sender: TObject);
Begin
   frm_Champions.ShowModal;
End;

Procedure Tfrm_Mines.FormClose(Sender: TObject; var Action: TCloseAction);
Var F: File of Integer;
    tmp:Integer;
Begin
   AssignFile(F,CFileNameInit);
   Rewrite(F);
   tmp:= Ord(SkillLevel);
   Write(F,X,Y,tmp);
   CloseFile(F);
End;

Procedure Tfrm_Mines.mnitm_FileMinimizeClick(Sender: TObject);
Begin
   if (GameProcessing)and(not Pause) then begin
      bttn_Pause.Down   := True;
      bttn_PauseClick(Sender);
   end;
   Application.Minimize;
End;

Procedure Tfrm_Mines.mnitm_FilePauseClick(Sender: TObject);
Begin
   if (not GameProcessing) then Exit;
   if (Pause) then bttn_Pause.Down:= False
              else bttn_Pause.Down:= True;
   bttn_PauseClick(Sender);
End;

{$IFDEF USE_WMActivate}
Procedure TFrm_Mines.WMActivate(var Message: TWMActivate);
Begin
   inherited;
   if (GameProcessing) and (not Pause) and
      ((Message.Active = WA_INACTIVE) or
       (Message.Minimized = True)) then
   begin
      bttn_Pause.Down:= True;
      bttn_PauseClick(TObject(Message.ActiveWindow));
   end;
End;
{$ENDIF}

////////////////////////////////////////////////////////////////////////////////
//                               TImageCells                                  //
////////////////////////////////////////////////////////////////////////////////
Procedure TImageCells.WMLButtonDown(var msg: TWMLButtonDown);
Begin
   inherited;
   gLmsg:= msg;
   Field[msg.XPos div CSizeCell, msg.YPos div CSizeCell].LButtonDown;
End;

Procedure TImageCells.WMLButtonUp(var msg: TWMLButtonUp  );
Var point: TPoint;
Begin
   inherited;
   point.x:= msg.XPos;
   point.y:= msg.YPos;
   Field[gLmsg.XPos div CSizeCell, gLmsg.YPos div CSizeCell].LButtonUp(point);
End;

Procedure TImageCells.WMRButtonDown(var msg: TWMRButtonDown);
Begin
   //inherited;
   Field[msg.XPos div CSizeCell, msg.YPos div CSizeCell].RButtonDown;
End;

Procedure TImageCells.WMLButtonDblClk(var msg: TWMLButtonDblClk);
Begin
   //inherited;
   Self.WMLButtonDown( msg );
End;

Procedure TImageCells.WMRButtonDblClk(var msg: TWMRButtonDblClk);
Begin
   //inherited;
   Self.WMRButtonDown( msg );
End;

Procedure TImageCells.WMPaint(var Message: TWMPaint);
Var i, j: Integer;
Begin
   inherited;
   if isRefresh then begin
      for i:= 0 to X-1 do
         for j:= 0 to Y-1 do Field[i,j].Paint;
      isRefresh:= False;
   end;
End;

////////////////////////////////////////////////////////////////////////////////
//                         Others procedure & function                        //
////////////////////////////////////////////////////////////////////////////////
Function Statistics: String;
Begin
   Result:= 'Open: '  + IntToStr(openCount)     + #10#13 +
            'Close: ' + IntToStr(X*Y-openCount) + #10#13 +
            'Mines: ' + IntToStr(minesNumber)   + #10#13 +
            'Flags: ' + IntToStr(flagCount);
   if (not useCraters) then Exit;
   Result:= Result + #10#13 + 'Craters: ' + IntToStr(numberCraters);
End;

Procedure SaveResult;
Var curr: TRecord;
    i   : Integer;
    indx: Integer;
Begin
   if (X <> CSizeX[Ord(SkillLevel)]) or
      (Y <> CSizeY[Ord(SkillLevel)]) then Exit;

   frm_Champions.Load;

   if (gAllPage[0][Ord(SkillLevel)][10].Time <= StrToInt(frm_Mines.edt_Timer.Text)) then Exit;

   frm_Dialog.ShowModal;
   curr.Name:= UDialog.theLatterName;
   curr.Time:= StrToInt(frm_Mines.edt_Timer.Text);
   frm_Champions.InsertRecord( 0, SkillLevel, curr );
   frm_Champions.Save;
{}
   //   
   indx:= 10; // no compiller warning
   for i:= 10 downto 1 do
      if (gAllPage[0][Ord(SkillLevel)][i].Time = StrToInt(frm_Mines.edt_Timer.Text))
      then begin
         indx:= i;
         Break;
      end;
   //     
   case SkillLevel of
      SkillLevelBeginner    : frm_Champions.strgrd_Beginner    .Row:= indx;
      SkillLevelAmateur     : frm_Champions.strgrd_Amateur     .Row:= indx;
      SkillLevelProfessional: frm_Champions.strgrd_Professional.Row:= indx;
      SkillLevelCrazy       : frm_Champions.strgrd_Crazy       .Row:= indx;
   end;
   case SkillLevel of
      SkillLevelBeginner    : frm_Champions.strgrd_Beginner    .Col:= 0;
      SkillLevelAmateur     : frm_Champions.strgrd_Amateur     .Col:= 0;
      SkillLevelProfessional: frm_Champions.strgrd_Professional.Col:= 0;
      SkillLevelCrazy       : frm_Champions.strgrd_Crazy       .Col:= 0;
   end;
{}
   frm_Champions.ShowModal;
End;
////////////////////////////////////////////////////////////////////////////////

END.

