UNIT UAbout;

INTERFACE

USES Windows, Forms, Classes, Controls, StdCtrls, ExtCtrls;

TYPE
  Tfrm_About = class(TForm)
    Panel1         : TPanel;
    ProgramIcon    : TImage;
    lbl_ProductName: TLabel;
    lbl_Version    : TLabel;
    lbl_Copyright  : TLabel;
    lbl_Comments   : TLabel;
    lbl_Response   : TLabel;
    OKButton       : TButton;
    procedure OKButtonKeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

VAR
  frm_About: Tfrm_About;

IMPLEMENTATION

{$R *.DFM}

Procedure Tfrm_About.OKButtonKeyPress(Sender: TObject; var Key: Char);
Begin
   if (Key = #27) then frm_About.Close;
End;

Procedure Tfrm_About.FormActivate(Sender: TObject);
Var winX, winY: Integer;
Begin
   winX:= GetDeviceCaps(GetDC(GetDesktopWindow()),HorzRes);
   winY:= GetDeviceCaps(GetDC(GetDesktopWindow()),VertRes);
   ReleaseDC(GetDC(GetDesktopWindow()),GetDesktopWindow()); // ???
   Self.Left:= winX div 2 - Self.Width  div 2;
   Self.Top := winY div 2 - Self.Height div 2;
End;

END.

