UNIT UOptions;

INTERFACE

USES
  Windows, Forms, Classes, Controls, StdCtrls, ComCtrls, Buttons, ExtCtrls, Spin;

TYPE
  Tfrm_Options = Class(TForm)
                    rdgrp_SkillLevel: TRadioGroup;
                    grpbx_Size      : TGroupBox;
                    Panel1          : TPanel;
                    btbttn_Ok       : TBitBtn;
                    btbttn_Cancel   : TBitBtn;
                    spnedt_X        : TSpinEdit;
                    spnedt_Y        : TSpinEdit;
                    lbl_X           : TLabel;
                    lbl_Y           : TLabel;
                    procedure btbttn_OkClick(Sender: TObject);
                    procedure FormActivate  (Sender: TObject);
    procedure spnedt_Change(Sender: TObject);
                 private
                    { Private declarations }
                 public
                    { Public declarations }
                 End;

VAR
  frm_Options: Tfrm_Options;

IMPLEMENTATION

USES UMines;
{$R *.DFM}

Procedure Tfrm_Options.btbttn_OkClick(Sender: TObject);
Begin
   UMines.SkillLevel:= TSkillLevel(rdgrp_SkillLevel.ItemIndex);
   UMines.frm_Mines.ResetField(Sender);
   UMines.X:= spnedt_X.Value;
   UMines.Y:= spnedt_Y.Value;
   UMines.frm_Mines.CreateField(Sender);
End;

Procedure Tfrm_Options.FormActivate(Sender: TObject);
Var winX, winY: Integer;
Begin
   winX:= GetDeviceCaps(GetDC(GetDesktopWindow()),HorzRes);
   winY:= GetDeviceCaps(GetDC(GetDesktopWindow()),VertRes);
   ReleaseDC(GetDC(GetDesktopWindow()),GetDesktopWindow()); // ???
   Self.Left:= winX div 2 - Self.Width  div 2;
   Self.Top := winY div 2 - Self.Height div 2;
   rdgrp_SkillLevel.ItemIndex:= Ord(UMines.SkillLevel);
   spnedt_X.Value:= UMines.X;
   spnedt_Y.Value:= UMines.Y;
End;

Procedure Tfrm_Options.spnedt_Change(Sender: TObject);
Begin
   if (spnedt_X.Value > CSizeX[3]) then spnedt_X.Value:= CSizeX[3];
   if (spnedt_Y.Value > CSizeY[3]) then spnedt_Y.Value:= CSizeY[3];
   if (spnedt_X.Value < CSizeX[0]) then spnedt_X.Value:= CSizeX[0];
   if (spnedt_Y.Value < CSizeY[0]) then spnedt_Y.Value:= CSizeY[0];
End;

END.
